{* ҥ windows apCһs@AwקAYDΫĳAw E-Mail
   rogerher@gigigaga.com *}

unit Bomb;

{$R BOMBIMG.RES}    

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, ExtCtrls, Graphics, Buttons;

type
  TModuleResult = (mrNone, mrSuccess, mrFail);

  TBomb = class(TCustomControl)
  private
    { Private declarations }
    FXGrid, FYGrid, FBombs : BYTE;      //CBelƤΦap
    FGrids : array of array of BYTE;    //CӮlA
    FPreviewEnable : Boolean;           // Control iw

    FFlagNum : integer;                 //wХܪXl
    FOKFlagNum: integer;                //TХܥXapl
    FCheckedNum : integer;              //wˬd(})l

    FFinished : Boolean;                //CO_w(NBz Mouse Event)
    FStart    : Boolean;                //C}l(Ĳo OnStart)
    FModuleResult : TModuleResult;      //A(mrSuccess? mrFail?)

    FOnFinished : TNotifyEvent;         //Event ~BzCɪu@
    FOnStart    : TNotifyEvent;         //Event ~BzC}lɪu@
    FOnFlagNumChange: TNotifyEvent;     //Event ~BzХܺXmɪu@
                                        //(uƴ@)

    (* |Ψ쪺Ϥ *)
    BombPic   : TBitmap;        //u
    FlagPic   : TBitmap;        //Xl
    ErrFlagPic: TBitmap;        //пXl
    FireBombPic:TBitmap;        //zu

    procedure SetXGrids(Num: BYTE);     // ]wapϪ X e
    procedure SetYGrids(Num: BYTE);     // ]wapϪ Y 
    procedure SetBombNum(Num : BYTE);   // ]wapϪu
    procedure Press( XGrid, YGrid : integer );      //Uƹ䪺ʧ@
    procedure FastOpen( XGrid, YGrid : integer );   //kPɫUɩIs
    procedure InitBombs;                // Imu

    procedure ShowHand;                 // 쬵u Show XҦum

    (* BzƹT *)
    procedure WMMouseMove( var Msg : TWMMouseMove); message WM_MOUSEMOVE;
    procedure WMLButtonUp( var Msg : TWMLButtonUp); message WM_LBUTTONUP;
    procedure WMLButtonDown( var Msg : TWMLButtonDown); message WM_LBUTTONDOWN;

    procedure WMRButtonUp( var Msg : TWMRButtonUp); message WM_RBUTTONUP;
    procedure WMRButtonDown( var Msg : TWMRButtonDown); message WM_RBUTTONDOWN;

  protected
    { Protected declarations }
    procedure Paint;    override;   // ۦBzapϪøs

    //apϪl 16x16ACanResize ΨapϪjp 16 
    function CanResize(var NewWidth, NewHeight: Integer): Boolean; override;

  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
  published
    { Published declarations }
    property XGrid : BYTE read FXGrid write SetXGrids default 9;
    property YGrid : BYTE read FYGrid write SetYGrids default 9;
    property BombNum : BYTE read FBombs write SetBombNum default 20;
    property FlagNum : integer read FFlagNum;
    property Finished : Boolean read FFinished;

    (* ~DCOLΥ *)
    property ModuleResult : TModuleResult read FModuleResult;

    (* ~۩w Event Bz禡 *)
    property OnStart    : TNotifyEvent read FOnStart write FOnStart;
    property OnFinished : TNotifyEvent read FOnFinished write FOnFinished;
    property OnFlagNumChange: TNotifyEvent read FOnFlagNumChange write FOnFlagNumChange;
  end;

procedure Register;

implementation

(* AX *)
const IsEmpty = 0;
const IsOne   = 1;
const IsTwo   = 2;
const IsThree = 3;
const IsFour  = 4;
const IsFive  = 5;
const IsSix   = 6;
const IsBomb  = $10;
const IsDown  = $20;
const IsFlag  = $40;
const IsChecked=$80;
const IsFireBomb=$FF;


{ Ʀr 1 ~ 8 OܤPC }
const TextColor : array[1..8] of integer = (clBlue,clGreen,clRed,clPurple,
                                            clBlack, clBlack, clBlack, clBlack );

const MAX_BOMB = 200;
                                            
var
  OldXGrid : integer;
  OldYGrid : integer;
  bRLDbDown: Boolean;      // kPɫ?
  bLButtonDown : Boolean;   //

function TBomb.CanResize(var NewWidth, NewHeight: Integer): Boolean;
begin
  SetLength( FGrids, 0, 0 );

  { Grid  16x16 AҥHnվ㦨 16  }
  FXGrid := NewWidth div 16;
  FYGrid := NewHeight div 16;

  if( FXGrid < 5 ) then FXGrid := 5;
  if( FYGrid < 5 ) then FYGrid := 5;

  { تe׬ 6 pixels }
  NewWidth := FXGrid * 16 + 6;
  NewHeight := FYGrid * 16 + 6;

  (* ]wG}Ce *)
  SetLength( FGrids, FXGrid, FYGrid );

  inherited CanResize(NewWidth,NewHeight);

  InitBombs;
  CanResize := True;
end;


constructor TBomb.Create(AOwner: TComponent);
begin
  inherited;
  // ww 9 * 9 }C(ج 3 pixels)
  Width := 9 * 16 + 3 * 2;
  Height:= Width;

  (* q Resource J *)
  if not (csDesignInstance in ComponentState) then
  begin
    // аO~(аOaSu)
    ErrFlagPic := TBitmap.Create;
    ErrFlagPic.LoadFromResourceName(hInstance,'ERRFLAG');
    // u
    BombPic := TBitmap.Create;
    BombPic.LoadFromResourceName(hInstance,'BOMB1');
    // zu
    FireBombPic := TBitmap.Create;
    FireBombPic.LoadFromResourceName(hInstance,'FIREBOMB');
    // аOXm
    FlagPic := TBitmap.Create;
    FlagPic.LoadFromResourceName(hInstance, 'FLAG');

    Cursor := crHandPoint;
  end;

  (* w]apϬ 9 x 9 A20 u *)
  FBombs :=  20;
  FXGrid :=   9;
  FYGrid :=   9;
  FPreviewEnable := False;

  (* tmOѪAΡAémap *)
  SetLength( FGrids, FXGrid, FYGrid );
  InitBombs;

  Canvas.Font.Style := [fsBold];        // ]

  bRLDbDown    := False;
end;

destructor TBomb.Destroy;
begin
  SetLength( FGrids, 0, 0 );    // k٪AΪOŶ


  (* kٹϤϥΪOŶ *)
  if not (csDesignInstance in ComponentState) then
  begin
    FlagPic.Free;
    BombPic.Free;
    FireBombPic.Free;
    ErrFlagPic.Free;
  end;
  inherited;
end;


procedure TBomb.FastOpen(XGrid, YGrid: integer);
var
  x,y : integer;
  FlagNum : integer;
begin
  (* ֥[g@FXX *)
  FlagNum := 0;
  for y:=-1 to 1 do
    for x:=-1 to 1 do
      if ((XGrid+X) in [0..FXGrid-1]) and ((YGrid+Y) in [0..FYGrid-1]) and
         ((FGrids[XGrid+x,YGrid+y] and IsFlag) = IsFlag ) then
           Inc(FlagNum);

  (* XƬO_󪬺AƦrAYOܩP򪺦apwQХܥX *)
  if FlagNum = (FGrids[XGrid,YGrid] and $0F) then
    for y:=-1 to 1 do
      for x:=-1 to 1 do
        if ((XGrid+X) in [0..FXGrid-1]) and ((YGrid+Y) in [0..FYGrid-1]) and
           ((FGrids[XGrid+x,YGrid+y] and (IsFlag or IsChecked)) = 0 ) then
           Press(XGrid+X,YGrid+Y);

end;

procedure TBomb.InitBombs;
var
  cnt,x,y,i,j : integer;
begin
  (* lƨpܼƤΪA *)
  FFlagNum := 0;
  FOKFlagNum := 0;
  FCheckedNum := 0;

  FStart := False;
  FFinished := False;
  FModuleResult := mrNone;

  SetLength( FGrids, 0, 0);
  SetLength( FGrids, FXGrid, FYGrid );


  cnt := 0;

  (* mu *)
  Randomize;
  while cnt < FBombs do
  begin
    x := Random(FXGrid);
    y := Random(FYGrid);
    if (FGrids[x,y] and $F0) = 0 then   // O_w?(٨S񬵼u)
    begin
       FGrids[x,y] := IsBomb;   // mu
       Inc(Cnt);
       (* NP򪺼Ʀr[1 *)
        for i := -1 to 1 do
          for j := -1 to 1 do
            if ((i<>0) or (j<>0)) and ((x+j) in [0..FXGrid-1]) and ((y+i) in [0..FYGrid-1]) then
               inc( FGrids[x+j,y+i] );
    end;
  end;

  FStart := False;
  FFinished := False;
  Invalidate;
end;

procedure TBomb.Paint;
var
  R : TRect;
  X,Y : integer;
  XGd, YGd : integer;
begin
  inherited Paint;
  (* e~ *)
  R :=  Rect(0,0,Width,Height);
  Frame3D( Canvas,R ,clBtnShadow,clBtnHighlight,3);

  (* eps *)
  Y := 3;
  YGd := 0;
  while Y < (Height-3) do
  begin
    X := 3;
    XGd := 0;
    while X < (Width-3) do
    begin
      R := Bounds(X,Y,16,16);

      if  FGrids[XGd,YGd] >= IsChecked then   // pGwgL
      begin
        if FGrids[XGd,YGd] = IsFireBomb then
           Canvas.Draw(X,Y, FireBombPic)      // ezap
        else if (FGrids[XGd,YGd] and IsBomb) = IsBomb  then
                Canvas.Draw(X,Y,BombPic)      // eap
             else if (FGrids[XGd,YGd] and (IsBomb or IsDown or IsFlag) ) = 0 then
                  (* Oap]SXhܼƦr *)
                  begin
                    Canvas.Brush.Color := RGB(192,192,192);
                    Canvas.Pen.Color := RGB(128,128,128);
                    Canvas.Rectangle(R.Left-1, R.Top-1, R.Right, R.Bottom);
                    Canvas.Font.Color := TextColor[FGrids[XGd,YGd] and $F];
                    if( (FGrids[XGd,YGd] and $F)> 0 ) then
                      Canvas.TextOut( R.Left+4,R.Top+1, IntToStr(FGrids[XGd,YGd] and $F) );
                  end;
      end
      else      // ٨SL
          if (FGrids[XGd,YGd] and IsFlag) = IsFlag then
          begin
            if not Finished then
              Canvas.Draw(X,Y, FlagPic)     // eXl
            else if (FGrids[XGd,YGd] and IsBomb) = 0 then // Хܿ~u
                    Canvas.Draw(X,Y,ErrFlagPic)     // ezu
                 else
                    Canvas.Draw(X,Y, FlagPic)
          end
          else if (FGrids[XGd,YGd] and IsDown) = IsDown then
               begin
                  Canvas.Pen.Color := RGB(128,128,128);
                  Canvas.Rectangle(R.Left-1, R.Top-1, R.Right, R.Bottom);
               end
               else
                begin
                   Canvas.Brush.Color := RGB(192,192,192);
                   Canvas.Rectangle(R);
                   Frame3D( Canvas, R, clBtnHighlight, clBtnShadow, 2 );
                end;

      inc(X,16);
      Inc(XGd); // U@
    end;
    inc(Y, 16);
    inc(YGd);   // U@C
  end;
end;


procedure TBomb.Press(XGrid, YGrid: integer);
var
  R : TRect;
  X,Y : integer;
begin

  (* YWXdΤwgLhBz *)
  if not( XGrid in [0..FXGrid-1] ) or not( YGrid in [0..FYGrid-1] ) then exit;
  if( FGrids[XGrid,YGrid] >= IsChecked ) then exit;

  (* Ĥ@UƹݳBz OnStart Event *)
  if ( FStart = False ) then
  begin
    FStart := True;
    if Assigned( FOnStart ) then FOnStart(self);
  end;

  R := Bounds( (XGrid * 16)+3, (YGrid * 16)+3, 16, 16);

  FGrids[XGrid, YGrid] := FGrids[XGrid, YGrid] or IsChecked;    // ]w}
  Inc( FCheckedNum );


  case ( FGrids[XGrid,YGrid] and (IsBomb or IsFlag ) ) of
    IsEmpty :   (* }aOw *)
      begin
        R := Bounds( (XGrid * 16)+3, (YGrid * 16)+3, 16, 16);
        InvalidateRect(Handle, @R, False );
      end;
    IsBomb :    (* 쬵u! C浲G mrFailA Show XҦu *)
      begin
        FGrids[XGrid, YGrid] := FGrids[XGrid, YGrid] or IsChecked or IsFireBomb;
        Canvas.Draw(R.Left,R.Top, FireBombPic);
        FModuleResult := mrFail;
        ShowHand;
      end;

  end;

  (* Ҧlwȶ}? YOܹC *)
  if( FCheckedNum = (FXGrid * FYGrid) ) then
  begin
    FFinished := True;
    FModuleResult := mrSuccess;
    if Assigned(FOnFinished) then FOnFinished(self);
  end;

  (* YOwϫhjIs Press() *)
  if (FFinished = False) and ((FGrids[XGrid][YGrid] and $5F)= 0) then
    for X := -1 to 1 do
      for Y := -1 to 1 do
       if ( {((X<>0) or (Y<>0)) and} ((XGrid+X) >= 0) and ((XGrid+X) < FXGrid) and
            ((YGrid+Y) >= 0) and ((YGrid+Y) < FYGrid) and ((FGrids[XGrid+X][YGrid+Y] and ( IsFlag or IsChecked)) = 0)) then
         Press(XGrid+X,YGrid+Y);

end;

procedure TBomb.SetBombNum(Num: BYTE);
begin
  if( Num <= MAX_BOMB ) then // uW 200 
  begin
    if Num >= (FXGrid * FYGrid) then
      FBombs := (FXGrid * FYGrid) div 2
    else
      FBombs := Num;

    InitBombs;
  end
  else
  begin
    FBombs := (FXGrid * FYGrid) div 2;
    InitBombs;
  end;
end;


procedure TBomb.SetXGrids(Num: BYTE);
begin
  if (Num >= 9 ) and (Num < 31) then    //  X eצb 9 ~ 30 
  begin
    Width :=  Num * 16 + 3 (*BevelWidth*) *2;;
    FXGrid := Num;

    SetLength( FGrids, 0, 0);           // kٰO
    SetLength( FGrids, FXGrid, FYGrid );// stmO
    InitBombs;                          // Iu
  end;
end;

procedure TBomb.SetYGrids(Num: BYTE);
begin
  if (Num >= 9) and (Num < 25) then     //  Y צb 9 ~ 25 
  begin
    Height:= Num * 16 + 3 (*BevelWidth*) *2;
    FYGrid := Num;

    SetLength( FGrids, 0, 0);           // kٰO
    SetLength( FGrids, FXGrid, FYGrid );// stmO
    InitBombs;                          // Iu
  end;
end;


procedure TBomb.ShowHand;
var
  X, Y : integer;
begin

  (* apܴNܥXҦap *)
  if FModuleResult = mrFail then
  begin
    for Y:= 0 to FYGrid-1 do
      for X:=0 to FXGrid-1 do
        if( FGrids[X,Y] and IsBomb ) = IsBomb  then
          FGrids[X,Y] := FGrids[X,Y] or IsChecked;
  end
  (* \LhFXa~} *)
  else if FModuleResult = mrSuccess then
  begin
    for Y:= 0 to FYGrid-1 do
      for X:=0 to FXGrid-1 do
        if( FGrids[X,Y] and IsFlag ) = 0  then
          FGrids[X,Y] := FGrids[X,Y] or IsChecked;
  end;
  Invalidate;   // eap

  FFinished := True;

  if Assigned( FOnFinished ) then   // ϥΪ̫w OnFinished Procedure
     FOnFinished(self);
end;


procedure TBomb.WMLButtonDown(var Msg: TWMLButtonDown);
var
  R : TRect;
  x,y : integer;
begin
  inherited;

  if Finished then exit;

  (* p@ Grid *)
  OldXGrid := (Msg.XPos - 3) div 16;
  OldYGrid := (Msg.YPos - 3) div 16;
  if not( OldXGrid in [0..FXGrid-1] ) or not( OldYGrid in [0..FYGrid-1] ) then exit;

  R := Bounds( (OldXGrid*16)+3, (OldYGrid*16)+3, 16, 16 );

  (* ˬdO_SUƹk *)
  if (Msg.Keys and MK_RBUTTON) = 0  then
  begin
    (* pGwХܺXlΤw}Lh exitA_høsW *)
    if(FGrids[OldXGrid,OldYGrid] and IsFlag ) = IsFlag then exit;
    bLButtonDown := True;

    if( FGrids[OldXGrid,OldYGrid] >= IsChecked ) then exit;

    Canvas.Rectangle(R);
  end
  else
  begin  (* PɫUƹk *)
    bRLDbDown := True;  // NOkPɫܼƳ] True
    (* Ng򪺤βΧאּWA *)
    for y:=-1 to 1 do
      for x:=-1 to 1 do
        if ((OldXGrid+X) in [0..FXGrid-1]) and ((OldYGrid+Y) in [0..FYGrid-1]) and
           (FGrids[OldXGrid+x,OldYGrid+y] < IsChecked) then
           FGrids[OldXGrid+x,OldYGrid+y] := FGrids[OldXGrid+x,OldYGrid+y] or IsDown;
    (* s *)
    InflateRect( R, 16, 16 );
    IntersectRect( R, R, Bounds(3,3,Width-6,Height-6) );
    InvalidateRect( Handle, @R, False );
  end;

end;

procedure TBomb.WMLButtonUp(var Msg: TWMLButtonUp);
var
  XGrid, YGrid : integer;
  x,y : integer;
  R : TRect;
begin
  inherited;

  bLButtonDown := False;

  if Finished then exit;    // pGCwhBzƹ䪺ʧ@

  (* p@ Grid *)
  XGrid := (Msg.XPos - 3) div 16;
  YGrid := (Msg.YPos - 3) div 16;

  if not(XGrid in [0..FXGrid-1]) or (not(YGrid in [0..FYGrid-1])) then exit;

  R := Bounds( XGrid*16+3, YGrid*16+3, 16, 16);

  // O_Pɫk //
  if bRLDbDown  then
  begin
    (* ٭gWA *)
    for y:=-1 to 1 do
      for x:=-1 to 1 do
        if ((XGrid+X) in [0..FXGrid-1]) and ((YGrid+Y) in [0..FYGrid-1]) then
           FGrids[XGrid+x,YGrid+y] := FGrids[XGrid+x,YGrid+y] and (not IsDown);
    InflateRect( R, 16, 16 );
    IntersectRect( R, R, Bounds(3,3,Width-6,Height-6) );

    if (Msg.Keys and MK_RBUTTON) = 0 then       // Pɩ}
    begin
      FastOpen( XGrid, YGrid );                 // ֳt}
      bRLDbDown := False;
    end;
  end
  else
    Press(XGrid, YGrid);

  InvalidateRect( Handle, @R, False );

end;


procedure TBomb.WMMouseMove(var Msg: TWMMouseMove);
var
  XGrid, YGrid : integer;
  R : TRect;
  x, y : integer;
begin
  inherited;

  (* pĴX Grid *)
  XGrid := (Msg.XPos - 3) div 16;
  YGrid := (Msg.YPos - 3) div 16;

  // Bz Control ɪw\
  if ( XGrid in [0..FXGrid-1] ) and ( YGrid in [0..FYGrid-1] ) then
  begin
    if((Msg.Keys and MK_CONTROL) = MK_CONTROL) then
    begin
      if FPreviewEnable then
      begin
        // ٭
        if (OldXGrid <> XGrid) or (OldYGrid <> YGrid) then
        begin
          FGrids[OldXGrid,OldYGrid] := FGrids[OldXGrid,OldYGrid] and (not IsChecked);
          R := Bounds( (OldXGrid*16)+3, (OldYGrid*16)+3, 16, 16 );
          InvalidateRect(Handle, @R, False );
        end;
        //
      end;
      if ((FGrids[XGrid,YGrid] and IsChecked) <> IsChecked) then
      begin
        // w
        if (OldXGrid <> XGrid) or (OldYGrid <> YGrid) then
        begin
          OldXGrid := XGrid;
          OldYGrid := YGrid;
          FGrids[XGrid,YGrid] := FGrids[XGrid,YGrid] or IsChecked;
          R := Bounds( (XGrid*16)+3, (YGrid*16)+3, 16, 16 );
          InvalidateRect(Handle, @R, False );
          FPreviewEnable := True;
        end;
      end;
    end
    else if FPreviewEnable then // Control }٭A
    begin
      FGrids[OldXGrid,OldYGrid] := FGrids[OldXGrid,OldYGrid] and (not IsChecked);
      R := Bounds( (OldXGrid*16)+3, (OldYGrid*16)+3, 16, 16 );
      InvalidateRect(Handle, @R, False );
      FPreviewEnable := False;
    end;
  end
  else if FPreviewEnable then   // ƹXapϫ٭A
  begin
      FGrids[OldXGrid,OldYGrid] := FGrids[OldXGrid,OldYGrid] and (not IsChecked);
      R := Bounds( (OldXGrid*16)+3, (OldYGrid*16)+3, 16, 16 );
      InvalidateRect(Handle, @R, False );
      FPreviewEnable := False;
      OldXGrid := -1;
      OldYGrid := -1;
  end;

  (* pGƹ䤣 *)
  if bLButtonDown then
  begin
    (* ^_eWA *)
    if ((Msg.Keys and MK_LBUTTON) = MK_LBUTTON ) and ((OldXGrid <> XGrid) or
       (OldYGrid <> YGrid)) and
       (( OldXGrid in [0..FXGrid-1] ) and ( OldYGrid in [0..FYGrid-1] ) )  then
    begin
      R := Bounds( (OldXGrid*16)+3, (OldYGrid*16)+3, 16, 16 );

      (* O_]Uƹk *)
      if((Msg.Keys and MK_RBUTTON) = MK_RBUTTON) then
      begin
        for y:=-1 to 1 do
          for x:=-1 to 1 do
            if ((OldXGrid+X) in [0..FXGrid-1]) and ((OldYGrid+Y) in [0..FYGrid-1]) and
               (FGrids[OldXGrid+x,OldYGrid+Y] and (IsChecked or IsFlag) = 0 ) then
               FGrids[OldXGrid+x,OldYGrid+y] := FGrids[OldXGrid+x,OldYGrid+y] and (not IsDown);

        InflateRect( R, 16, 16 );
        InvalidateRect( Handle, @R, False );
      end
      else if (FGrids[OldXGrid,OldYGrid] < IsChecked) then
           Frame3D( Canvas, R, clBtnHighlight, clBtnShadow, 2 );
    end;


    (* ͫsWA *)
    if ((Msg.Keys and MK_LBUTTON) = MK_LBUTTON ) and (XGrid >= 0) and (XGrid < FXGrid) and
       (YGrid >= 0) and (YGrid < FYGrid) and
       ((OldXGrid <> XGrid) or (OldYGrid <> YGrid))  then
    begin
      R := Bounds( (XGrid*16)+3, (YGrid*16)+3, 16, 16 );
      OldXGrid := XGrid;
      OldYGrid := YGrid;

      if((Msg.Keys and MK_RBUTTON) = MK_RBUTTON) then
      begin
        for y:=-1 to 1 do
          for x:=-1 to 1 do
            if ((XGrid+X) in [0..FXGrid-1]) and ((YGrid+Y) in [0..FYGrid-1]) and ((FGrids[XGrid+x,YGrid+y] and (IsFlag or IsChecked)) = 0) then
               FGrids[XGrid+x,YGrid+y] := FGrids[XGrid+x,YGrid+y] or IsDown;

        InflateRect( R, 16, 16 );
        IntersectRect( R, R, Bounds(3,3, Width-6, Height-6 ) ); // hWXɪϰ
        InvalidateRect( Handle, @R, False );
      end
      else if ((FGrids[XGrid,YGrid] and (IsFlag or IsChecked)) = 0) then Canvas.Rectangle(R);

    end;
  end;
end;

procedure TBomb.WMRButtonDown(var Msg: TWMRButtonDown);
var
  XGd, YGd : Integer;
  R : TRect;
  x,y : integer;
begin
  inherited;

  if FFinished then exit;

  XGd := (Msg.XPos - 3) div 16;
  YGd := (Msg.YPos - 3) div 16;

  if ( XGd in [0..FXGrid-1] ) and ( YGd in [0..FYGrid-1] ) then
  begin
     if(Msg.Keys and MK_LBUTTON) = MK_LBUTTON then      // if kPɫ
     begin
        bRLDbDown := True;
        OldXGrid := XGd;
        OldYGrid := YGd;
        for y:=-1 to 1 do
          for x:=-1 to 1 do
            if ((XGd+X) in [0..FXGrid-1]) and ((YGd+Y) in [0..FYGrid-1]) and
               ((FGrids[XGd+X][YGd+Y] and IsChecked) = 0) then
               FGrids[XGd+x,YGd+y] := FGrids[XGd+x,YGd+y] or IsDown;
        InflateRect( R, 16, 16 );
        IntersectRect( R, R, Bounds(3,3,Width-6,Height-6) );
        InvalidateRect( Handle, @R, False );
     end
     else if ( FGrids[XGd,YGd] < IsChecked) then
     begin
       FGrids[XGd,YGd] := FGrids[XGd,YGd] xor IsFlag;

       if(FGrids[XGd,YGd] and IsFlag) = IsFlag then
       begin
          Canvas.Draw( XGd*16+3, YGd*16+3, FlagPic);
          inc( FFlagNum );
          if Assigned(FOnFlagNumChange) then FOnFlagNumChange(self);
          if( FGrids[XGd,YGd] and IsBomb) = IsBomb  then
          begin
            Inc( FCheckedNum );
            Inc( FOKFlagNum );
            if(FOKFlagNum = FBombs) then
            begin
              FFinished := True;
              FModuleResult := mrSuccess;
              ShowHand;
            end
            else
            if( FCheckedNum = (FXGrid * FYGrid) ) then
            begin
              FFinished := True;
              FModuleResult := mrSuccess;
              if Assigned(FOnFinished) then FOnFinished(self);
            end;
          end;
       end
       else
       begin
          R := Bounds( XGd*16+3, YGd*16+3, 16, 16);
          Canvas.Rectangle(R);
          Frame3D( Canvas, R, clBtnHighlight, clBtnShadow, 2 );
          Dec( FFlagNum );
          if Assigned(FOnFlagNumChange) then FOnFlagNumChange(self);
          if( FGrids[XGd,YGd] and IsBomb) = IsBomb  then
              Dec(FOKFlagNum );
       end;

     end;
  end;
end;

procedure TBomb.WMRButtonUp(var Msg: TWMRButtonUp);
var
  x, y : integer;
  XGd, YGd : integer;
  R : TRect;
begin
  inherited;

  XGd := (Msg.XPos - 3) div 16;
  YGd := (Msg.YPos - 3) div 16;

  if bRLDbDown then
  begin
    R := Bounds( (XGd*16)+3, (YGd*16)+3, 16, 16 );

    for y:=-1 to 1 do
      for x:=-1 to 1 do
        if ((XGd+X) in [0..FXGrid-1]) and ((YGd+Y) in [0..FYGrid-1]) and
           (FGrids[XGd+x,YGd+y] and (IsChecked or IsFlag) = 0 )then
           FGrids[XGd+x,YGd+y] := FGrids[XGd+x,YGd+y] and (not IsDown);
    InflateRect( R, 16, 16 );
    IntersectRect( R, R, Bounds(3,3,Width-6,Height-6) );

    if (Msg.Keys and MK_LBUTTON) = 0 then       // k䳣}
    begin
      FastOpen(XGd,YGd);
      bRLDbDown := False;
    end;

    InvalidateRect( Handle, @R, False );
  end;
end;

procedure Register;
begin
  RegisterComponents('Users', [TBomb]);
end;

end.
